/**
 * Function to show a scroll to top button if the user has scrolled down
 * 250 pixels from the headline element.
 */
function scrollToTop(scrollToElementSelector, triggerElementSelector) {
  let headline = document.querySelector(scrollToElementSelector);
  let scrollToTop = document.querySelector(triggerElementSelector);
  window.addEventListener('scroll', (event) => {
    if (pageYOffset > 250) {
      scrollToTop.classList.toggle('hide', false);
    } else {
      scrollToTop.classList.toggle('hide', true);
    }
  });
  scrollToTop.onclick = () => {
    headline.scrollIntoView({behavior: 'smooth', block: 'end', inline: 'nearest'});
  };
}

// export function
export { scrollToTop };